##Input_layer=vector
##North_CRS=crs EPSG:4284
##Output_layer=output vector

from qgis.core import *
from PyQt4.QtCore import *
import math

DLATS = [1737.42, 5700.2, 0.015625]

layer = processing.getObject(Input_layer)
wkbtype = layer.wkbType()
crs = layer.dataProvider().crs()
fields = layer.pendingFields()
fname = 'Field{:d}'.format(fields.count() + 1)
fields.append(QgsField(fname, QVariant.Double, "Real", 13, 8))
crs0 = QgsCoordinateReferenceSystem(North_CRS)
t = QgsCoordinateTransform(crs, crs0)
dlat = DLATS[crs0.mapUnits()]
writer = QgsVectorFileWriter(Output_layer, 'UTF-8', fields, wkbtype, crs, 'ESRI Shapefile')
if writer.hasError() != QgsVectorFileWriter.NoError:
    raise GeoAlgorithmExecutionException('Error creating shapefile')

iter = layer.getFeatures()
n = layer.featureCount()
i = 0
for f in iter:
    g = f.geometry()
    pt0 = t.transform(g.asPoint().x(), g.asPoint().y(), 0)
    pt1 = t.transform(pt0.x(), pt0.y() - dlat, 1)
    pt2 = t.transform(pt0.x(), pt0.y() + dlat, 1)
    a = math.degrees(math.atan2(pt1.x() - pt2.x(), pt2.y() - pt1.y()))
    attrs = f.attributes()
    attrs.append(a)
    f.setAttributes(attrs)
    writer.addFeature(f)
    i = i + 1
    progress.setPercentage(int(i / n * 100))

del writer
